package com.jeequan.jeepay.thirdparty.channel.lklspay.payway;

import cn.hutool.core.date.DateUnit;
import cn.hutool.core.date.DateUtil;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.jeequan.jeepay.core.constants.CS;
import com.jeequan.jeepay.core.entity.PayOrder;
import com.jeequan.jeepay.core.model.context.MchAppConfigContext;
import com.jeequan.jeepay.core.model.rqrs.AbstractRS;
import com.jeequan.jeepay.core.model.rqrs.msg.ChannelJsapiMsg;
import com.jeequan.jeepay.core.model.rqrs.msg.ChannelRetMsg;
import com.jeequan.jeepay.core.model.rqrs.payorder.UnifiedOrderRQ;
import com.jeequan.jeepay.core.model.rqrs.payorder.payway.AliBarOrderRS;
import com.jeequan.jeepay.core.model.rqrs.payorder.payway.AliQrOrderRQ;
import com.jeequan.jeepay.core.model.rqrs.payorder.payway.AliQrOrderRS;
import com.jeequan.jeepay.thirdparty.channel.lklspay.LklspayKit;
import com.jeequan.jeepay.thirdparty.channel.lklspay.LklspayPaymentService;
import com.jeequan.jeepay.thirdparty.channel.lklspay.model.LklPayMethod;
import com.jeequan.jeepay.thirdparty.util.ApiResBuilder;
import org.springframework.stereotype.Service;

/**
 * 拉卡拉 支付宝NATIVE
 *
 * @author xiaoyu
 *
 * @date 2022/5/24 17:38
 */
@Service("lklspayPaymentByAliQrService") //Service Name需保持全局唯一性
public class AliQr extends LklspayPaymentService {

    @Override
    public String preCheck(UnifiedOrderRQ rq, PayOrder payOrder) {
        return null;
    }

    @Override
    public AbstractRS pay(UnifiedOrderRQ rq, PayOrder payOrder, MchAppConfigContext mchAppConfigContext){
        AliQrOrderRQ bizRQ = (AliQrOrderRQ)rq;
        ChannelRetMsg channelRetMsg = new ChannelRetMsg();
        AliQrOrderRS res = ApiResBuilder.buildSuccess(AliBarOrderRS.class);
        JSONObject bizContent = new JSONObject();
        // 默认支付参数
        LklspayKit.setPayParams(mchAppConfigContext, bizContent,payOrder.getClientIp());
        bizContent.put("out_trade_no",payOrder.getPayOrderId());
        bizContent.put("total_amount",payOrder.getFindAmt());
        bizContent.put("account_type", "NATIVE");
        bizContent.put("trans_type","41");
        bizContent.put("subject",payOrder.getSubject());
        bizContent.put("notify_url",getNotifyUrl());
        bizContent.put("settle_type","0");
        bizContent.put("remark",payOrder.getBuyerRemark());
        JSONObject acc_busi_fields = new JSONObject();
        Integer hbFqNum = bizRQ.getHbFqNum();
        if(hbFqNum != null){
            JSONObject extend_params = new JSONObject();
            extend_params.put("hb_fq_num",hbFqNum);
            extend_params.put("hb_fq_seller_percent",0);
            acc_busi_fields.put("extend_params",extend_params);
        }
        Integer limitPay = bizRQ.getLimitPay();
        if(limitPay != null && limitPay == 1){
            acc_busi_fields.put("disable_pay_channels","credit_group");
        }
        String expiredTime = DateUtil.formatBetween(DateUtil.between(payOrder.getCreatedAt(), payOrder.getExpiredTime(), DateUnit.MINUTE)).replace("毫秒", "");
        acc_busi_fields.put("timeout_express",expiredTime);
        bizContent.put("acc_busi_fields",acc_busi_fields);
        JSONObject response = LklspayKit.payRequest(LklPayMethod.Api.TRANS_PREORDER, mchAppConfigContext.getMchApplyment(), bizContent);
        JSONObject payInfo = this.initResult(response, channelRetMsg);
        if(payInfo != null){
            String qrCdUrl = payInfo.getString("code");
            ChannelJsapiMsg jsapiMsg = new ChannelJsapiMsg();
            if(CS.PAY_DATA_TYPE.CODE_IMG_URL.equals(bizRQ.getPayDataType())){
                jsapiMsg.setQrCodeUrl(sysConfigService.getDBApplicationConfig().genScanImgUrl(qrCdUrl));
                res.setCodeImgUrl(sysConfigService.getDBApplicationConfig().genScanImgUrl(qrCdUrl));
            }else{
                jsapiMsg.setQrCodeUrl(qrCdUrl);
                res.setCodeUrl(qrCdUrl);
            }
            res.setPayData(JSON.toJSONString(jsapiMsg));
        }
        res.setChannelRetMsg(channelRetMsg);
        return res;
    }

}
